## rustc-1.77 1.77.2%2Bdfsg1ubuntu1~bpo0

=== src/llvm-project/compiler-rt/lib/stats/CMakeLists.txt ===
set(STATS_HEADERS
  stats.h)

include_directories(..)

add_custom_target(stats)
set_target_properties(stats PROPERTIES FOLDER "Compiler-RT Misc")

if(APPLE)
  set(STATS_LIB_FLAVOR SHARED)

  set(STATS_LINK_LIBS ${SANITIZER_COMMON_LINK_LIBS})

  add_weak_symbols("asan" WEAK_SYMBOL_LINK_FLAGS)
  add_weak_symbols("ubsan" WEAK_SYMBOL_LINK_FLAGS)
  add_weak_symbols("sanitizer_common" WEAK_SYMBOL_LINK_FLAGS)
else()
  set(STATS_LIB_FLAVOR STATIC)

  set(WEAK_SYMBOL_LINK_FLAGS)
endif()

add_compiler_rt_runtime(clang_rt.stats
  ${STATS_LIB_FLAVOR}
  ARCHS ${SANITIZER_COMMON_SUPPORTED_ARCH}
  OS ${STATS_SUPPORTED_OS}
  SOURCES stats.cpp
  ADDITIONAL_HEADERS ${STATS_HEADERS}
  OBJECT_LIBS RTSanitizerCommon
              RTSanitizerCommonLibc
              RTSanitizerCommonSymbolizer
  CFLAGS ${SANITIZER_COMMON_CFLAGS}
  LINK_FLAGS ${SANITIZER_COMMON_LINK_FLAGS} ${WEAK_SYMBOL_LINK_FLAGS}
  LINK_LIBS ${STATS_LINK_LIBS}
  PARENT_TARGET stats)

add_compiler_rt_runtime(clang_rt.stats_client
  STATIC
  ARCHS ${SANITIZER_COMMON_SUPPORTED_ARCH}
  OS ${STATS_SUPPORTED_OS}
  SOURCES stats_client.cpp
  ADDITIONAL_HEADERS ${STATS_HEADERS}
  CFLAGS ${SANITIZER_COMMON_CFLAGS}
  LINK_FLAGS ${WEAK_SYMBOL_LINK_FLAGS}
  PARENT_TARGET stats)

## rustc-1.77 1.77.2+dfsg1ubuntu1~bpo0

=== tests/run-make-fulldeps/hotplug_codegen_backend/Makefile ===
include ../../run-make/tools.mk

# ignore-stage1

# This test both exists as a check that -Zcodegen-backend is capable of loading external codegen
# backends and that this external codegen backend is only included in the dep info if
# -Zbinary-dep-depinfo is used.

all:
	$(RUSTC) the_backend.rs --crate-name the_backend --crate-type dylib \
		-o $(TMPDIR)/the_backend.dylib

	$(RUSTC) some_crate.rs --crate-name some_crate --crate-type lib -o $(TMPDIR)/some_crate \
		-Z codegen-backend=$(TMPDIR)/the_backend.dylib -Z unstable-options \
		--emit link,dep-info
	grep -x "This has been \"compiled\" successfully." $(TMPDIR)/libsome_crate.rlib
	# don't declare a dependency on the codegen backend if -Zbinary-dep-depinfo isn't used.
	grep -v "the_backend.dylib" $(TMPDIR)/some_crate.d
	
	$(RUSTC) some_crate.rs --crate-name some_crate --crate-type lib -o $(TMPDIR)/some_crate \
		-Z codegen-backend=$(TMPDIR)/the_backend.dylib -Z unstable-options \
		--emit link,dep-info -Zbinary-dep-depinfo
	grep -x "This has been \"compiled\" successfully." $(TMPDIR)/libsome_crate.rlib
	# but declare a dependency on the codegen backend if -Zbinary-dep-depinfo it used.
	grep "the_backend.dylib" $(TMPDIR)/some_crate.d

=== tests/run-make/debug-assertions/Makefile ===
# ignore-cross-compile
# needs-unwind
include ../tools.mk

all:
	$(RUSTC) debug.rs -C debug-assertions=no
	$(call RUN,debug) good
	$(RUSTC) debug.rs -C opt-level=0
	$(call RUN,debug) bad
	$(RUSTC) debug.rs -C opt-level=1
	$(call RUN,debug) good
	$(RUSTC) debug.rs -C opt-level=2
	$(call RUN,debug) good
	$(RUSTC) debug.rs -C opt-level=3
	$(call RUN,debug) good
	$(RUSTC) debug.rs -C opt-level=s
	$(call RUN,debug) good
	$(RUSTC) debug.rs -C opt-level=z
	$(call RUN,debug) good
	$(RUSTC) debug.rs -O
	$(call RUN,debug) good
	$(RUSTC) debug.rs
	$(call RUN,debug) bad
	$(RUSTC) debug.rs -C debug-assertions=yes -O
	$(call RUN,debug) bad
	$(RUSTC) debug.rs -C debug-assertions=yes -C opt-level=1
	$(call RUN,debug) bad

=== tests/run-make/extern-fn-generic/Makefile ===
# ignore-cross-compile
include ../tools.mk

all: $(call NATIVE_STATICLIB,test)
	$(RUSTC) testcrate.rs
	$(RUSTC) test.rs
	$(call RUN,test) || exit 1

=== tests/run-make/inaccessible-temp-dir/Makefile ===
# only-linux
# ignore-arm - linker error on `armhf-gnu`

include ../tools.mk

# Issue #66530: We would ICE if someone compiled with `-o /dev/null`,
# because we would try to generate auxiliary files in `/dev/` (which
# at least the OS X file system rejects).
#
# An attempt to `-Ztemps-dir` into a directory we cannot write into should
# indeed be an error; but not an ICE.
#
# However, some folks run tests as root, which can write `/dev/` and end
# up clobbering `/dev/null`. Instead we'll use an inaccessible path, which
# also used to ICE, but even root can't magically write there.
#
# Note that `-Ztemps-dir` uses `create_dir_all` so it is not sufficient to
# use a directory with non-existing parent like `/does-not-exist/output`.

all:
	# Create an inaccessible directory
	mkdir $(TMPDIR)/inaccessible
	chmod 000 $(TMPDIR)/inaccessible

	# Run rustc with `-Ztemps-dir` set to a directory 
	# *inside* the inaccessible one, so that it can't create it
	$(RUSTC) program.rs -Ztemps-dir=$(TMPDIR)/inaccessible/tmp 2>&1 \
		| $(CGREP) 'failed to find or create the directory specified by `--temps-dir`'

	# Make the inaccessible directory accessible,
	# so that compiletest can delete the temp dir
	chmod +rw $(TMPDIR)/inaccessible

=== tests/run-make/incremental-debugger-visualizer/Makefile ===
include ../tools.mk

# This test makes sure that changes to files referenced via #[debugger_visualizer]
# are picked up when compiling incrementally.

# We have to copy the source to $(TMPDIR) because Github CI mounts the source
# directory as readonly. We need to apply modifications to some of the source
# file.
SRC_DIR := $(TMPDIR)/src
INCR_CACHE_DIR := $(TMPDIR)/incremental

all:
	rm -rf $(TMPDIR)/*
	mkdir $(SRC_DIR)
	cp ./foo.rs $(SRC_DIR)
	echo "GDB script v1" > $(SRC_DIR)/foo.py
	echo "Natvis v1" > $(SRC_DIR)/foo.natvis
	$(RUSTC) $(SRC_DIR)/foo.rs \
	  --crate-type=rlib \
	  --emit metadata \
	  -C incremental=$(INCR_CACHE_DIR) \
	  -Z incremental-verify-ich
	$(CGREP) "GDB script v1" < $(TMPDIR)/libfoo.rmeta
	$(CGREP) "Natvis v1" < $(TMPDIR)/libfoo.rmeta

	# Change only the GDB script and check that the change has been picked up
	echo "GDB script v2" > $(SRC_DIR)/foo.py
	$(RUSTC) $(SRC_DIR)/foo.rs \
	  --crate-type=rlib \
	  --emit metadata \
	  -C incremental=$(INCR_CACHE_DIR) \
	  -Z incremental-verify-ich

	$(CGREP) "GDB script v2" < $(TMPDIR)/libfoo.rmeta
	$(CGREP) -v "GDB script v1" < $(TMPDIR)/libfoo.rmeta
	$(CGREP) "Natvis v1" < $(TMPDIR)/libfoo.rmeta

	# Now change the Natvis version and check that the change has been picked up
	echo "Natvis v2" > $(SRC_DIR)/foo.natvis
	$(RUSTC) $(SRC_DIR)/foo.rs \
	  --crate-type=rlib \
	  --emit metadata \
	  -C incremental=$(INCR_CACHE_DIR) \
	  -Z incremental-verify-ich

	$(CGREP) "GDB script v2" < $(TMPDIR)/libfoo.rmeta
	$(CGREP) -v "GDB script v1" < $(TMPDIR)/libfoo.rmeta
	$(CGREP) "Natvis v2" < $(TMPDIR)/libfoo.rmeta
	$(CGREP) -v "Natvis v1" < $(TMPDIR)/libfoo.rmeta

=== tests/run-make/libtest-json/Makefile ===
# ignore-cross-compile
# needs-unwind
include ../tools.mk

# Test expected libtest's JSON output

OUTPUT_FILE_DEFAULT := $(TMPDIR)/libtest-json-output-default.json
OUTPUT_FILE_STDOUT_SUCCESS := $(TMPDIR)/libtest-json-output-stdout-success.json

all: f.rs validate_json.py output-default.json output-stdout-success.json
	$(RUSTC) --test f.rs
	RUST_BACKTRACE=0 $(call RUN,f) -Z unstable-options --test-threads=1 --format=json > $(OUTPUT_FILE_DEFAULT) || true
	RUST_BACKTRACE=0 $(call RUN,f) -Z unstable-options --test-threads=1 --format=json --show-output > $(OUTPUT_FILE_STDOUT_SUCCESS) || true

	cat $(OUTPUT_FILE_DEFAULT) | "$(PYTHON)" validate_json.py
	cat $(OUTPUT_FILE_STDOUT_SUCCESS) | "$(PYTHON)" validate_json.py

	# Normalize the actual output and compare to expected output file
	cat $(OUTPUT_FILE_DEFAULT) | sed 's/"exec_time": [0-9.]*/"exec_time": $$TIME/' | diff output-default.json -
	cat $(OUTPUT_FILE_STDOUT_SUCCESS) | sed 's/"exec_time": [0-9.]*/"exec_time": $$TIME/' | diff output-stdout-success.json -

=== tests/run-make/long-linker-command-lines/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) foo.rs -g -O
	RUSTC="$(RUSTC_ORIGINAL)" $(call RUN,foo)

=== tests/run-make/pgo-gen-lto/Makefile ===
# needs-profiler-support
# ignore-windows-gnu
# ignore-cross-compile

# FIXME(mati865): MinGW GCC miscompiles compiler-rt profiling library but with Clang it works
# properly. Since we only have GCC on the CI ignore the test for now.

include ../tools.mk

COMPILE_FLAGS=-Copt-level=3 -Clto=fat -Cprofile-generate="$(TMPDIR)"

all:
	$(RUSTC) $(COMPILE_FLAGS) test.rs
	$(call RUN,test) || exit 1
	[ -e "$(TMPDIR)"/default_*.profraw ] || (echo "No .profraw file"; exit 1)

=== tests/run-make/rlib-chain/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) m1.rs
	$(RUSTC) m2.rs
	$(RUSTC) m3.rs
	$(RUSTC) m4.rs
	$(call RUN,m4)
	rm $(TMPDIR)/*lib
	$(call RUN,m4)

=== tests/run-make/static-unwinding/Makefile ===
# ignore-cross-compile
# needs-unwind
include ../tools.mk

all:
	$(RUSTC) lib.rs
	$(RUSTC) main.rs
	$(call RUN,main)

=== tests/run-make/wasm-panic-small/Makefile ===
include ../tools.mk

# only-wasm32-bare

all:
	$(RUSTC) foo.rs -C lto -O --target wasm32-unknown-unknown --cfg a
	wc -c < $(TMPDIR)/foo.wasm
	[ "`wc -c < $(TMPDIR)/foo.wasm`" -lt "1024" ]
	$(RUSTC) foo.rs -C lto -O --target wasm32-unknown-unknown --cfg b
	wc -c < $(TMPDIR)/foo.wasm
	[ "`wc -c < $(TMPDIR)/foo.wasm`" -lt "5120" ]
	$(RUSTC) foo.rs -C lto -O --target wasm32-unknown-unknown --cfg c
	wc -c < $(TMPDIR)/foo.wasm
	[ "`wc -c < $(TMPDIR)/foo.wasm`" -lt "5120" ]
	$(RUSTC) foo.rs -C lto -O --target wasm32-unknown-unknown --cfg d
	wc -c < $(TMPDIR)/foo.wasm
	[ "`wc -c < $(TMPDIR)/foo.wasm`" -lt "5120" ]

=== src/llvm-project/clang-tools-extra/clang-apply-replacements/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Support
  )

add_clang_library(clangApplyReplacements
  lib/Tooling/ApplyReplacements.cpp
)

clang_target_link_libraries(clangApplyReplacements
  PRIVATE
  clangAST
  clangBasic
  clangRewrite
  clangToolingCore
  clangToolingRefactoring
  )

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  include
  )
add_subdirectory(tool)

=== debian/changelog ===
rustc-1.77 (1.77.2+dfsg1ubuntu1~bpo0-0ubuntu0.22.04) jammy; urgency=medium

  * Backport to Jammy (LP: #2070410)
    - d/rules: fix the dollar symbol escaping
    - d/p/ubuntu-backport-disable-newer-tests.patch: add a patch to disable
      newer tests that can't pass on older Ubuntu series
    - d/p/ubuntu-jammy-skip-gdb-tests-on-armhf.patch: add a patch to
      disable gdb tests on armhf
    - Re-enable libgit2 vendoring:
      - d/control: remove libgit2-dev and libhttp-parser-dev from B-D
    - Re-enable LLVM vendoring (LLVM 17)
    - d/control: Comment out the Vendored-Sources-Rust support as it's
      not available in older releases
    - d/p/d-0010-cargo-remove-vendored-c-crates.patch: disable modern sqlite3
      APIs as we don't have a modern sqlite3 on older series

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 14 Aug 2024 23:28:21 -0600

rustc-1.77 (1.77.2+dfsg1ubuntu1-0ubuntu1) oracular; urgency=medium

  [ Zixing Liu ]

  * New upstream release 1.77.2 (LP: #2070410)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.77
    - d/patches: remove obsoleted patches   
    - d/s/lintian-overrides*: update lintian overrides
    - d/control: update vendored crate list
  * d/p/ubuntu-add-s390x-allowed-features.patch: fix s390x build with backchain
  * d/tests: fix self-build tests when rust-defaults package does not point to
    the current versioned package
  * d/control: Build-Depends solely on versioned packages

  [ Fabian Grünbichler ]

  * config: don't attempt to optimize compiler-rt
  * update upstream unsuspicious files

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 08 Jul 2024 23:49:29 -0600

rustc-1.76 (1.76.0+dfsg0ubuntu1-0ubuntu1) oracular; urgency=medium

  * New upstream release 1.76.0 (LP: #2052985)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.76
    - d/patches: remove obsoleted patches
    - d/s/lintian-overrides: update lintian overrides
    - d/control: update vendored crate list
    - d/p/ubuntu-upgrade-cc-to-1.0.85.patch: backport cc 1.0.85
    - d/p/d-0022-rust-by-example-strip-embedded-libs.patch: strip embedded
      CSS and JS libraries
    - d/p/d-bootstrap-cargo-doc-paths.patch: remove patch and build Cargo book
  * Remove libllvm17 dependency due to time_t transition renaming
  * d/p/ubuntu-skip-gdb-tests.patch: temporarily disables gdb tests to
    workaround test failures.
  * Transition Rust toolchain package to a versioned scheme (LP: #2054748)
    - d/*: move all the scripts to the <name>-X.Y.in format so that they
      are generated per version
    - d/rules: install files into their per-version directories
    - d/cargo-*: use a wrapper script to help cargo select the rustc binary
    - d/rules, d/cargo-X.Y.install.in: try to fix the installation logic
    - d/control.in: remove libllvm17 from B-D as it breaks the build after
      armhf time_t 64 bit transition
  * d/get-stage0.py: fix stage0 download
  * d/rules: add checks for checking source package
    - Re-generate auto-generated files if the input files are changed
    - Check if the source package name in the changelog is correct
    - Check and delete auto-generated files on dh_clean

 -- Zixing Liu <zixing.liu@canonical.com>  Fri, 07 Jun 2024 10:25:10 +0200

rustc (1.75.0+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.75.0 (LP: #2047858)
    - d/patches: Refresh patches
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/libstd-rust-*: bump version to 1.75
    - d/patches: remove obsoleted patches
    - d/s/lintian-overrides: update lintian overrides
    - d/control: update vendored crate list

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 02 Jan 2024 12:09:03 -0700

rustc (1.74.1+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.74.1 (LP: #2044036)
    - d/patches: Refresh patches
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: remove new
      Windows dependencies
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data and add LGPL 2.1 license texts
    - d/p/d-fix-rustix-outline.patch: re-add rustix fix for 1.74
    - d/p/ubuntu-upgrade-libgit2-to-1.7.patch: remove obsoleted patch
    - d/libstd-rust-*: bump version to 1.74
    - d/rules: apply a workaround to avoid dh_dwz complaining about
      "Too many DIEs, not optimizing"

 -- Zixing Liu <zixing.liu@canonical.com>  Sun, 19 Nov 2023 18:04:52 -0700

rustc (1.73.0+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.73.0 (LP: #2040340)
    - d/patches: Refresh patches
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: remove new
      Windows dependencies
    - d/p/d-0020-remove-windows-dependencies.patch: remove references to macOS
      and Windows libraries in Cargo credential query logic
    - d/p/ubuntu-fix-short-ice-test.patch: remove obsoleted patch
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/control: bump Rust toolchain B-D requirements to 1.72
    - d/control: update the list of vendored dependencies
    - d/*: bump LLVM requirements to LLVM 17
    - d/s/lintian-overrides: suppress Lintian warnings about prebuilt Windows
      binaries in libloading-0.7.4. They are required by libloading for the tests
    - d/cargo.install: remove cargo-credential-1password plugin since now this
      functionality is builtin and no longer ships as a plugin

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 24 Oct 2023 22:29:46 -0600

rustc (1.72.1+dfsg0ubuntu1-0ubuntu1) mantic; urgency=medium

  * Cherry-pick new changes from Debian until Rust 1.70 (LP: #2041325)
    Applied:
    - Disable download tests
    - Fix internal cargo-doc links


=== debian/control ===
Source: rustc-1.77
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
# dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.76 | cargo-1.77 <!pkg.rustc.dlstage0>,
 rustc-1.76 | rustc-1.77 <!pkg.rustc.dlstage0>,
 cmake (>= 3.20) | cmake3 (>= 3.20),
# needed by some vendor crates
 pkgconf,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libsqlite3-dev,
# Required for llvm build
 autotools-dev,
 m4,
 ninja-build,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
RUST_PREV_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)-1}')
RUST_NEXT_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)+1}')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
RUST_DESTDIR ?= /usr
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
# compiler
export TARGET_CFLAGS = $(CFLAGS)
export TARGET_CXXFLAGS = $(CXXFLAGS)
export TARGET_CPPFLAGS = $(CPPFLAGS)
export TARGET_LDFLAGS = $(LDFLAGS)
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# Let rustbuild control whether LLVM is compiled with debug symbols, rather
# than compiling with debug symbols unconditionally, which will fail on
# 32-bit architectures
CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Cargo-specific flags
export LIBSSH2_SYS_USE_PKG_CONFIG=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

# autopkgtest-related logic
ifneq (,$(RUST_TEST_SELFBUILD))
RUST_DESTDIR = /usr/lib/rust-$(RUST_VERSION)
endif

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

# List generated files
FILES_TO_PRECONFIGURE := $(wildcard debian/*.in)
FILES_TO_PRECONFIGURE_OUT := $(subst X.Y,$(RUST_VERSION),\
  $(filter-out debian/control,\
    $(patsubst %.in,%,$(FILES_TO_PRECONFIGURE))\
  )\
)
DEFINED_SRC_NAME = $(shell dpkg-parsechangelog -S Source)

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

override_dh_clean: debian/control
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/preconfigure.stamp: $(FILES_TO_PRECONFIGURE) debian/changelog
ifneq ($(DEFINED_SRC_NAME),rustc-$(RUST_VERSION))
	$(error Source package name is incorrect:\
	  Source: $(DEFINED_SRC_NAME), expected: rustc-$(RUST_VERSION). Please check d/changelog)
endif
	for f in debian/*.in debian/source/*.in; do \
		f2=$$(echo $$f | sed 's/\.in$$//;s/X\.Y/$(RUST_VERSION)/'); \
		echo "$$f => $$f2"; \
		sed -e 's|@RUST_VERSION@|$(RUST_VERSION)|g' \

## rustc-1.77 1.77.2+dfsg1ubuntu1

=== tests/run-make/alloc-no-sync/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --edition=2021 -Dwarnings --crate-type=rlib ../../../library/alloc/src/lib.rs --cfg no_sync

=== tests/run-make/c-link-to-rust-staticlib/Makefile ===
# ignore-cross-compile
include ../tools.mk

# ignore-freebsd
# FIXME

all:
	$(RUSTC) foo.rs
	$(CC) bar.c $(call STATICLIB,foo) $(call OUT_EXE,bar) \
		$(EXTRACFLAGS) $(EXTRACXXFLAGS)
	$(call RUN,bar)
	rm $(call STATICLIB,foo)
	$(call RUN,bar)

=== tests/run-make/c-static-dylib/Makefile ===
# ignore-cross-compile
include ../tools.mk

all: $(call NATIVE_STATICLIB,cfoo)
	$(RUSTC) foo.rs -C prefer-dynamic
	$(RUSTC) bar.rs
	rm $(call NATIVE_STATICLIB,cfoo)
	$(call RUN,bar)
	$(call REMOVE_DYLIBS,foo)
	$(call FAIL,bar)

=== tests/run-make/cdylib/Makefile ===
# ignore-cross-compile
include ../tools.mk

all: $(call RUN_BINFILE,foo)
	$(call RUN,foo)
	rm $(call DYLIB,foo)
	$(RUSTC) foo.rs -C lto
	$(call RUN,foo)

ifdef IS_MSVC
$(call RUN_BINFILE,foo): $(call DYLIB,foo)
	$(CC) $(CFLAGS) foo.c $(TMPDIR)/foo.dll.lib $(call OUT_EXE,foo)
else
$(call RUN_BINFILE,foo): $(call DYLIB,foo)
	$(CC) $(CFLAGS) foo.c -lfoo -o $(call RUN_BINFILE,foo) -L $(TMPDIR)
endif

$(call DYLIB,foo):
	$(RUSTC) bar.rs
	$(RUSTC) foo.rs

=== tests/run-make/exit-code/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) success.rs; [ $$? -eq 0 ]
	$(RUSTC) --invalid-arg-foo; [ $$? -eq 1 ]
	$(RUSTC) compile-error.rs; [ $$? -eq 1 ]
	RUSTC_ICE=0 $(RUSTC) -Ztreat-err-as-bug compile-error.rs; [ $$? -eq 101 ]
	$(RUSTDOC) -o $(TMPDIR)/exit-code success.rs; [ $$? -eq 0 ]
	$(RUSTDOC) --invalid-arg-foo; [ $$? -eq 1 ]
	$(RUSTDOC) compile-error.rs; [ $$? -eq 1 ]
	$(RUSTDOC) lint-failure.rs; [ $$? -eq 1 ]

=== tests/run-make/issue-40535/Makefile ===
include ../tools.mk

# The ICE occurred in the following situation:
# * `foo` declares `extern crate bar, baz`, depends only on `bar` (forgetting `baz` in `Cargo.toml`)
# * `bar` declares and depends on `extern crate baz`
# * All crates built in metadata-only mode (`cargo check`)
all:
	# cc https://github.com/rust-lang/rust/issues/40623
	$(RUSTC) baz.rs --emit=metadata
	$(RUSTC) bar.rs --emit=metadata --extern baz=$(TMPDIR)/libbaz.rmeta
	$(RUSTC) foo.rs --emit=metadata --extern bar=$(TMPDIR)/libbar.rmeta 2>&1 | \
		$(CGREP) -v "unexpectedly panicked"
	# ^ Succeeds if it doesn't find the ICE message

=== tests/run-make/issue-46239/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	$(RUSTC) main.rs -C opt-level=1
	$(call RUN,main)

=== tests/run-make/link-dedup/Makefile ===
# ignore-msvc

include ../tools.mk

all:
	$(RUSTC) depa.rs
	$(RUSTC) depb.rs
	$(RUSTC) depc.rs
	$(RUSTC) empty.rs --cfg bar 2>&1 | $(CGREP) '"-ltesta" "-ltestb" "-ltesta"'
	$(RUSTC) empty.rs 2>&1 | $(CGREP) '"-ltesta"'
	$(RUSTC) empty.rs 2>&1 | $(CGREP) -v '"-ltestb"'
	$(RUSTC) empty.rs 2>&1 | $(CGREP) -v '"-ltesta" "-ltesta" "-ltesta"'

=== tests/run-make/llvm-ident/Makefile ===
include ../tools.mk

# only-linux

all:
	# `-Ccodegen-units=16 -Copt-level=2` is used here to trigger thin LTO
	# across codegen units to test deduplication of the named metadata
	# (see `LLVMRustPrepareThinLTOImport` for details).
	echo 'fn main(){}' | $(RUSTC) - --emit=link,obj -Csave-temps -Ccodegen-units=16 -Copt-level=2 --target=$(TARGET)

	# `llvm-dis` is used here since `--emit=llvm-ir` does not emit LLVM IR
	# for temporary outputs.
	"$(LLVM_BIN_DIR)"/llvm-dis $(TMPDIR)/*.bc

	# Check LLVM IR files (including temporary outputs) have `!llvm.ident`
	# named metadata, reusing the related codegen test.
	set -e; for f in $(TMPDIR)/*.ll; do \
		$(LLVM_FILECHECK) --input-file $$f ../../codegen/llvm-ident.rs; \
	done

=== tests/run-make/metadata-dep-info/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --emit=metadata,dep-info --crate-type lib dash-separated.rs -C extra-filename=_something-extra
	# Strip TMPDIR since it is a machine specific absolute path
	sed "s%.*[/\\]%%" "$(TMPDIR)"/dash-separated_something-extra.d > "$(TMPDIR)"/dash-separated_something-extra.normalized.d
	$(RUSTC_TEST_OP) "$(TMPDIR)"/dash-separated_something-extra.normalized.d dash-separated_something-extra.normalized.d

=== tests/run-make/no-cdylib-as-rdylib/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Test that rustc will not attempt to link against a cdylib as if
# it is a rust dylib when an rlib for the same crate is available.
# Previously rustc didn't actually check if any further formats of
# a crate which has been loaded are of the same version and if
# they are actually valid. This caused a cdylib to be interpreted
# as rust dylib as soon as the corresponding rlib was loaded. As
# cdylibs don't export any rust symbols, linking would fail if
# rustc decides to link against the cdylib rather than the rlib.

all:
	$(RUSTC) bar.rs --crate-type=rlib --crate-type=cdylib
	$(RUSTC) foo.rs -C prefer-dynamic
	$(call RUN,foo)

=== tests/run-make/panic-abort-eh_frame/Makefile ===
# only-linux
#
# This test ensures that `panic=abort` code (without `C-unwind`, that is) should not have any
# unwinding related `.eh_frame` sections emitted.

include ../tools.mk

all:
	$(RUSTC) foo.rs --crate-type=lib --emit=obj=$(TMPDIR)/foo.o -Cpanic=abort --edition 2021 -Z validate-mir
	objdump --dwarf=frames $(TMPDIR)/foo.o | $(CGREP) -v 'DW_CFA'

=== debian/changelog ===
rustc-1.77 (1.77.2+dfsg1ubuntu1-0ubuntu0.24.04) noble; urgency=medium

  * Backport to Noble (LP: #2070410)
    - d/rules: fix the dollar symbol escaping

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 14 Aug 2024 23:06:31 -0600

=== debian/control ===
--- 
+++ 
@@ -12,12 +12,16 @@
 Build-Depends:
  debhelper (>= 9),
  debhelper-compat (= 13),
-# dh-cargo (>= 28ubuntu1~),
+ dh-cargo (>= 28ubuntu1~),
  dpkg-dev (>= 1.17.14),
  python3:native,
  cargo-1.76 | cargo-1.77 <!pkg.rustc.dlstage0>,
  rustc-1.76 | rustc-1.77 <!pkg.rustc.dlstage0>,
- cmake (>= 3.20) | cmake3 (>= 3.20),
+ llvm-17-dev:native,
+ llvm-17-tools:native,
+ libclang-rt-17-dev (>= 1:17.0.2),
+ libclang-common-17-dev (>= 1:17.0.2),
+ cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
  pkgconf,
 # this is sometimes needed by rustc_llvm
@@ -29,11 +33,10 @@
  bash-completion,
  libcurl4-gnutls-dev | libcurl4-openssl-dev,
  libssh2-1-dev,
+ libgit2-dev (>= 1.7.0),
+ libgit2-dev (<< 1.8~~),
+ libhttp-parser-dev,
  libsqlite3-dev,
-# Required for llvm build
- autotools-dev,
- m4,
- ninja-build,
 # test dependencies:
  binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
  git <!nocheck>,
@@ -51,6 +54,7 @@
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
+ clang-17:native,
  libssl-dev,
 Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
 Standards-Version: 4.6.2

=== debian/rules ===
--- 
+++ 
@@ -35,20 +35,34 @@
 # for dh_install substitution variable
 export DEB_HOST_RUST_TYPE
 
-# Let rustbuild control whether LLVM is compiled with debug symbols, rather
-# than compiling with debug symbols unconditionally, which will fail on
-# 32-bit architectures
-CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-
 # for dh_install substitution variable
 export RUST_LONG_VERSION
 export RUST_VERSION
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
+# Use system LLVM (comment out to use vendored LLVM)
+LLVM_VERSION = 17
+OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
+# used by the patched profiler build script
+CLANG_RT_ARCH := $(DEB_TARGET_GNU_CPU)
+ifeq (i386,$(DEB_TARGET_ARCH))
+CLANG_RT_ARCH = i386
+endif
+ifeq (armhf,$(DEB_TARGET_ARCH))
+CLANG_RT_ARCH = armhf
+endif
+export DEB_LLVM_VERSION = $(LLVM_VERSION)
+export DEB_CLANG_RT_ARCH = $(CLANG_RT_ARCH)
 # Cargo-specific flags
 export LIBSSH2_SYS_USE_PKG_CONFIG=1
+# Make it easier to test against a custom LLVM
+ifneq (,$(LLVM_DESTDIR))
+LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
+LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
+export LD_LIBRARY_PATH
+endif
+
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 ifeq ($(DEB_HOST_ARCH),riscv64)
 NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -194,12 +208,3 @@
 	# Upstream contains a lot of these
 	dh_clean -XCargo.toml.orig
 
-debian/preconfigure.stamp: $(FILES_TO_PRECONFIGURE) debian/changelog
-ifneq ($(DEFINED_SRC_NAME),rustc-$(RUST_VERSION))
-	$(error Source package name is incorrect:\
-	  Source: $(DEFINED_SRC_NAME), expected: rustc-$(RUST_VERSION). Please check d/changelog)
-endif
-	for f in debian/*.in debian/source/*.in; do \
-		f2=$$(echo $$f | sed 's/\.in$$//;s/X\.Y/$(RUST_VERSION)/'); \
-		echo "$$f => $$f2"; \
-		sed -e 's|@RUST_VERSION@|$(RUST_VERSION)|g' \
